<template>
  <el-dialog title="New user" :visible.sync="dialogVisible" @close="cancelForm()">
    <el-form :model="user" :rules="rules" status-icon>
      <h3>User information</h3>

      <el-form-item label="Username" prop="username" required :error="errors.username">
        <el-input v-model="user.username"></el-input>
      </el-form-item>

      <el-form-item label="Email" prop="emails.0.email" :error="errors.emails_0_email">
        <el-input v-model="user.emails[0].email"></el-input>
      </el-form-item>

      <el-form-item label="Password" prop="password" required :error="errors.password">
        <el-input v-model="user.password" type="password"></el-input>
      </el-form-item>

      <el-form-item label="Password confirmation" prop="passwordConfirmation" required :error="errors.password_confirmation">
        <el-input v-model="user.passwordConfirmation" type="password"></el-input>
      </el-form-item>

      <el-form-item label="Role" prop="role" required :error="errors.role">
        <el-select v-model="user.role" style="width: 100%">
          <el-option label="User" value="user"></el-option>
          <el-option label="Agent" value="agent"></el-option>
          <el-option label="Manager" value="manager"></el-option>
          <el-option label="Administrator" value="administrator"></el-option>
        </el-select>
      </el-form-item>

      <h3>Personal information</h3>

      <el-form-item label="First name" prop="profile.firstName" required :error="errors.profile_first_name">
        <el-input v-model="user.profile.firstName"></el-input>
      </el-form-item>

      <el-form-item label="Last name" prop="profile.lastName" required :error="errors.profile_last_name">
        <el-input v-model="user.profile.lastName"></el-input>
      </el-form-item>

      <el-form-item label="Brithdate" prop="profile.birthdate" required :error="errors.profile_birthdate">
        <el-date-picker type="date" v-model="user.profile.birthdate" style="width: 100%"></el-date-picker>
      </el-form-item>

      <el-form-item label="Gender" prop="profile.gender" required :error="errors.profile_gender">
        <el-select v-model="user.profile.gender" style="width: 100%">
          <el-option label="Male" value="male"></el-option>
          <el-option label="Female" value="female"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="Country" prop="profile.countryCode" required :error="errors.profile_country_code">
        <el-select v-model="user.profile.countryCode" style="width: 100%">
          <el-option label="Argentina" value="AR"></el-option>
          <el-option label="Colombia" value="CO"></el-option>
          <el-option label="Venezuela" value="VE"></el-option>
        </el-select>
      </el-form-item>
    </el-form>

    <span slot="footer" class="dialog-footer">
      <el-button @click="cancelForm()">Cancel</el-button>
      <el-button type="primary" @click="submitForm()">Save</el-button>
    </span>
  </el-dialog>
</template>

<script>
import CreateUserMutation from '../../../graphql/mutations/create_user.gql'

export default {
  data() {
    return {
      dialogVisible: true,
      user: {
        username: '',
        password: '',
        passwordConfirmation: '',
        emails: [{ email: '' }],
        role: 'user',
        profile: {
          firstName: '',
          lastName: '',
          birthdate: '',
          gender: '',
          countryCode: ''
        }
      },
      rules: {
        emails: [{ email: [
          { required: true, message: 'email is required' },
          { type: 'email',  message: 'email is invalid' }
          ] }],
        password_confirmation: { required: true, message: 'password confirmation is required' }
      },
      errors: {
        username: '',
        password: '',
        password_confirmation: '',
        emails_0_email: '',
        role: '',
        profile_first_name: '',
        profile_last_name: '',
        profile_birthdate: '',
        profile_gender: '',
        profile_country_code: ''
      }
    }
  },

  methods: {
    submitForm() {
      this.$apollo.mutate({
        mutation: CreateUserMutation,
        variables: { user: this.$data.user },
        update: (store, { data: { createUser } }) => {
          if(createUser.success) {
            this.$message.success('User created successfully')
            this.$data.dialogVisible = false
            this.$router.push('/admin/users')
          }
          else{
            this.$message.error('Failed to create user')
            createUser.errors.forEach(error => { this.$data.errors[error.field] = error.message })
          }
        }
      })
    },
    cancelForm() {
      this.$data.dialogVisible = false
      this.$router.push('/admin/users')
    }
  }
}
</script>
